



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android必知必会-Stetho调试工具</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android必知必会-Stetho调试工具</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 09:27:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<h2>一、背景</h2>
<blockquote><p>Stetho是 Facebook 出品的一个强大的 Android 调试工具,使用该工具你可以在 Chrome Developer Tools查看<strong>APP的布局</strong>, <strong>网络请求</strong>(仅限使用Volle, okhttp的网络请求库), <strong>Sqlite</strong>, <strong>Preference</strong>, 一切都是<strong>可视化</strong>的操作,无须自己在去使用adb, 也<strong>不需要root</strong>你的设备</p></blockquote>
<p>本人使用自己的Nubia Z9 Mini作为调试机，由于牵涉到Sqlite数据库，所以尝试了很多办法把它Root了，然而Root之后就无法正常升级系统。 <br /><br />
今天得知一调试神器<code>Stetho</code>，无需Root就能查看数据库以及APP的布局（这一点没有Android Device Monitor使用方便，但是Android Device Monitor在Mac上总是莫名其妙出问题），使用起来很方便，大家可以尝试一下。</p>
<blockquote><p>转载请注明出处：<a href="http://blog.csdn.net/ys743276112" rel="external nofollow noreferrer">http://blog.csdn.net/ys743276112</a></p></blockquote>
<h2>二、配置流程</h2>
<h3>1.引入主库</h3>
<p><strong>使用Gradle方式：</strong></p>
<pre class="prettyprint linenums"><code>// Gradle dependency on Stetho<br />
  dependencies {<br />
    compile 'com.facebook.stetho:stetho:1.3.1'<br />
  } </code></pre>
<p>此外还支持<code>Maven</code>方式，这里不做介绍。</p>
<h3>2.引入网络请求库</h3>
<p>如果需要调试网络且你使用的网络请求库是Volle或者Okhttp，那么你才需要配置，否则跳过此步。 <br /><br />
以下根据自己使用的网络请求库情况来导入相应的库： <br /><br />
<strong>1.使用okhttp 2.X</strong></p>
<pre class="prettyprint linenums"><code> dependencies {<br />
    compile 'com.facebook.stetho:stetho-okhttp:1.3.1'<br />
  } </code></pre>
<p><strong>2.使用okhttp 3.X</strong></p>
<pre class="prettyprint linenums"><code>dependencies {<br />
    compile 'com.facebook.stetho:stetho-okhttp3:1.3.1'<br />
  } </code></pre>
<p><strong>3.使用HttpURLConnection</strong></p>
<pre class="prettyprint linenums"><code>dependencies {<br />
    compile 'com.facebook.stetho:stetho-urlconnection:1.3.1'<br />
  }</code></pre>
<h3>3.配置代码</h3>
<p>配置<code>Application</code></p>
<pre class="prettyprint linenums"><code>public class XXX extends Application {<br />
  public void onCreate() {<br />
    super.onCreate();<br />
    Stetho.initializeWithDefaults(this);<br />
  }<br />
}</code></pre>
<p>配置网络请求库： <br /><br />
<strong>OkHttp  2.2.x+ 或 3.x</strong></p>
<pre class="prettyprint linenums"><code>//方案一<br />
OkHttpClient client = new OkHttpClient();<br />
client.networkInterceptors().add(new StethoInterceptor());

//方案二<br />
new OkHttpClient.Builder()<br />
    .addNetworkInterceptor(new StethoInterceptor())<br />
    .build();</code></pre>
<p>如果使用的是<code>HttpURLConnection</code>，请查阅相关文档。</p>
<h3>4.使用</h3>
<p>运行重新编译后的APP程序，保持手机与电脑的连接，然后打开Chrome浏览器，在地址栏里输入：<code>chrome://inspect</code>然后选择自己的设备下运行的APP进程名下的<code>Inspect</code>链接 即可进行调试。</p>
<h2>三、遇到的问题</h2>
<h3>1.okhttp版本问题：</h3>
<p>可能你还在使用<code>okhttp 2.x</code>的版本，在引入网络库的时候，你需要去查看一下<code>Stetho</code>当前版本使用的<code>okhttp</code>版本，避免在项目中使用多个不同版本的<code>okhttp</code>。</p>
<p><strong>PS</strong>：<code>okhttp</code>2.x和3.x的引入方式略有不同，不可以直接修改版本号来导入：</p>
<pre class="prettyprint linenums"><code>//2.x<br />
compile 'com.squareup.okhttp:okhttp:2.x.x'<br />
//3.x<br />
compile 'com.squareup.okhttp3:okhttp:3.x.x'</code></pre>
<h3>2.配置okhttp代码方案一报错：</h3>
<pre class="prettyprint linenums"><code>//方案一<br />
OkHttpClient client = new OkHttpClient();<br />
client.networkInterceptors().add(new StethoInterceptor());

//方案二<br />
OkHttpClient client = new OkHttpClient.Builder()<br />
    .addNetworkInterceptor(new StethoInterceptor())<br />
    .build();</code></pre>
<p>我在使用<strong>方案一</strong>进行配置<code>okhttp</code>的时候，会报错：</p>
<pre class="prettyprint linenums"><code> Caused by: java.lang.UnsupportedOperationException</code></pre>
<p>不知道是不是兼容的问题，大家在使用的时候请注意。</p>
<blockquote><p><a href="http://facebook.github.io/stetho/" rel="external nofollow noreferrer">Stetho官网</a></p></blockquote>
<hr>
<blockquote><p>转载请注明出处：<a href="http://blog.csdn.net/ys743276112" rel="external nofollow noreferrer">http://blog.csdn.net/ys743276112</a></p></blockquote>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8z6z11q.html">Syncfusion 复选框 ComboBoxAdv</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y44r5q.html">rdtsc获取时间统计程序的运行效率</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn14p6j8.html">SQL Server 2008数据库创建，备份，还原图解及注意点</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjodoz9.html">&period;c 文件取为&period;o文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde4d609.html">HDU 1495  非常可乐  BFS 搜索</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn0wz6q.html">Python Cookbook笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydedxxq.html">Silverlight Socket 实现收发信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1wmzdq.html">ListView 使用方法（Asp&period;Net）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyovme9.html">读Zepto源码之代码结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gexmke8.html">replicated mode vs global mode - 每天5分钟玩转 Docker 容器技术（105）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p425n8.html">linux防火墙之 ufw</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj6ox28.html">学习React系列（九）&mdash;&mdash;高阶函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1e5x2q.html">模板设计在tomcat中的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g0jrmq.html">Tensorflow卷积神经网络&lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdo4wd9.html">python初认识、基础数据类型以及 if 流程控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllp111q.html">java MD5&sol;AES&sol;DES加解密汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vdx6zq.html">Oracle03--子查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/q44z40nq.html">第一个Django应用程序&lowbar;part3</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g33xx4q.html">The driver has not received any packets from the server</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlov7k6q.html">java成神之&mdash;&mdash;网络编程基本操作</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qy131odq.html">&lbrack;BZOJ&rsqb;1027 合金&lpar;JSOI2007&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgl5lm8.html">cmake   没有那个目录</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z1e2x9.html">AspNetCoreApi 跨域处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1we6zq.html">flask jQuery  ajax 上传文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo7vz3q.html">Python开发&mdash;&mdash;利用正则表达式实现计算器算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjyo3r8.html">Spring常用接口和类</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m5jeo8.html">CMD远程连接服务器上的MySQL</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkg5yd8.html">一些重要的计算机网络协议（IP、TCP、UDP、HTTP）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me4wvrq.html">CentOS Linux上安装Oracle11g笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1wrgzq.html">java&period;lang&period;NoSuchMethodException&colon; org&period;apache&period;catalina&period;deploy&period;WebXml addServlet</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
